SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest class methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 19:40'!
blueGhost
	^ GameCharacter new.! !

!PacManTest methodsFor: 'actors' stamp: 'GomezPanero 5/16/2012 20:27'!
blueGhost

	^ Ghost new.! !

!PacManTest methodsFor: 'movements' stamp: 'GomezPanero 5/16/2012 19:48'!
down

	^0@(-1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'GomezPanero 5/16/2012 20:29'!
ghostHouseDoorType

	^ GhostHouseDoorTile new.! !

!PacManTest methodsFor: 'movements' stamp: 'GomezPanero 5/16/2012 19:47'!
left

	 ^ -1@0.! !

!PacManTest methodsFor: 'construction block types' stamp: 'GomezPanero 5/16/2012 20:37'!
leftTransporterType

	^ LeftTransporterTile new.! !

!PacManTest methodsFor: 'actors' stamp: 'GomezPanero 5/16/2012 20:27'!
pacman

	^ Pacman  new.! !

!PacManTest methodsFor: 'movements' stamp: 'GomezPanero 5/16/2012 19:47'!
right

	^1@0.! !

!PacManTest methodsFor: 'construction block types' stamp: 'GomezPanero 5/16/2012 19:55'!
spaceType

	^ SpaceTile new.
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'GomezPanero 5/16/2012 19:48'!
up

	^0@1.! !

!PacManTest methodsFor: 'construction block types' stamp: 'GomezPanero 5/16/2012 19:46'!
wallType

	^ WallTile new .! !

Object subclass: #GameCharacter
	instanceVariableNames: 'currentPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GameCharacter methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 19:36'!
initialize

	currentPosition := 0@0 .! !

!GameCharacter methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 20:51'!
moveTo: aMovePermisionTile with: aDirection

	self subclassResponsibility .! !

!GameCharacter methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 19:37'!
position 

	^ currentPosition .! !

GameCharacter subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 20:51'!
moveTo: aMovePermisionTile with: aDirection

	^ aMovePermisionTile nextPositionForGhost: self going:  aDirection.! !

GameCharacter subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 20:52'!
moveTo: aMovePermisionTile with: aDirection

	^ aMovePermisionTile nextPositionForPacman: self going:  aDirection.! !

Object subclass: #Tile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

Tile subclass: #MovePermisionTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

MovePermisionTile subclass: #GhostHouseDoorTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorTile methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 20:38'!
nextPositionForGhost: aGhost going: aDirection

	 ^ aGhost position + aDirection.! !

!GhostHouseDoorTile methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 20:25'!
nextPositionForPacman: aPacman going: aDirection

	 ^ aPacman position .! !

MovePermisionTile subclass: #LeftTransporterTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterTile methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 20:39'!
nextPositionForGhost: aGhost going: aDirection

	 ^ aGhost position.! !

!LeftTransporterTile methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 20:38'!
nextPositionForPacman: aPacman going: aDirection

	 ^ 3@10.! !

!MovePermisionTile methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 20:48'!
nextPositionFor: aGameCharacter going: aDirection

	 ^ aGameCharacter moveTo:  self with: aDirection .! !

!MovePermisionTile methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 20:49'!
nextPositionForGhost: aGhost going: aDirection

	^ self subclassResponsibility .! !

!MovePermisionTile methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 20:49'!
nextPositionForPacman: aPacman going: aDirection

	^ self subclassResponsibility .! !

Tile subclass: #SpaceTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceTile methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 19:54'!
nextPositionFor: aGameCharacter going: aDirection

	 ^ aGameCharacter position + aDirection. ! !

!Tile methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 19:53'!
nextPositionFor: aGameCharacter going: aDirection

	self subclassResponsibility .! !

Tile subclass: #WallTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallTile methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/16/2012 19:46'!
nextPositionFor: aGameCharacter going: aDirection

	 ^ aGameCharacter position.
	! !
